package com.maintain.business.service;

import com.maintain.business.domain.ErpMaterialInventoryRecord;
import com.maintain.business.domain.vo.ErpMaterialInventoryRecordVo;
import com.maintain.business.domain.bo.ErpMaterialInventoryRecordBo;
import com.maintain.common.core.page.TableDataInfo;
import com.maintain.common.core.domain.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * 物料库存记录Service接口
 *
 * @author liushuai
 * @date 2025-07-16
 */
public interface IErpMaterialInventoryRecordService {

    /**
     * 查询物料库存记录
     */
    ErpMaterialInventoryRecordVo queryById(Long id);

    /**
     * 查询物料库存记录列表
     */
    TableDataInfo<ErpMaterialInventoryRecordVo> queryPageList(ErpMaterialInventoryRecordBo bo, PageQuery pageQuery);

    /**
     * 查询物料汇总记录列表(自定义查询)
     */
    TableDataInfo<ErpMaterialInventoryRecordVo> customQueryPageList(ErpMaterialInventoryRecordBo bo, PageQuery pageQuery);

    /**
     * 查询物料库存记录列表(自定义查询)
     */
    TableDataInfo<ErpMaterialInventoryRecordVo> customQueryPageInventoryList(ErpMaterialInventoryRecordBo bo, PageQuery pageQuery);

    /**
     * 查询物料库存记录列表
     */
    List<ErpMaterialInventoryRecordVo> queryListByMaterialId(ErpMaterialInventoryRecordBo bo);

    /**
     * 新增物料库存记录
     */
    Boolean insertByBo(ErpMaterialInventoryRecordBo bo);

    /**
     * 修改物料库存记录
     */
    Boolean updateByBo(ErpMaterialInventoryRecordBo bo);

    /**
     * 校验并批量删除物料库存记录信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);
}
